# mypy-boto3-greengrass

[![PyPI - mypy-boto3-greengrass](https://img.shields.io/pypi/v/mypy-boto3-greengrass.svg?color=blue)](https://pypi.org/project/mypy-boto3-greengrass)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-greengrass.svg?color=blue)](https://pypi.org/project/mypy-boto3-greengrass)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)

- [mypy-boto3-greengrass](#mypy-boto3-greengrass)
  - [How to use](#how-to-use)
  - [Automated type discovery](#automated-type-discovery)


Type annotations for
[boto3.Greengrass 1.13.26](https://boto3.amazonaws.com/v1/documentation/api/1.13.26/reference/services/greengrass.html#Greengrass) service
compatible with [mypy](https://github.com/python/mypy), [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/) and other tools.

Generated by [mypy-boto3-buider 2.0.2](https://github.com/vemel/mypy_boto3_builder).

More information can be found on [boto3-stubs](https://pypi.org/project/boto3-stubs/) page.

- [mypy-boto3-greengrass](#mypy-boto3-greengrass)
  - [How to use](#how-to-use)
    - [Type checking](#type-checking)
  - [How it works](#how-it-works)

## How to use

Make sure you have [mypy](https://github.com/python/mypy) installed and activated in your IDE.

Install `boto3-stubs` for `Greengrass` service.

```bash
python -m pip install boto3-stubs[greengrass]

# update installed packages index for automated type discovery
python -m mypy_boto3
```

Use `boto3` with `mypy_boto3_greengrass` in your project and enjoy type checking and auto-complete.

```python
import boto3

from mypy_boto3_greengrass import GreengrassClient

# Now mypy can check if your code is valid.
client: GreengrassClient = boto3.client("greengrass")

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: GreengrassClient = session.client("greengrass")



# Annotated paginators are included as well

import mypy_boto3_greengrass.paginator as greengrass_paginators

list_bulk_deployment_detailed_reports_paginator: greengrass_paginators.ListBulkDeploymentDetailedReportsPaginator = client.get_paginator("list_bulk_deployment_detailed_reports")
list_bulk_deployments_paginator: greengrass_paginators.ListBulkDeploymentsPaginator = client.get_paginator("list_bulk_deployments")
list_connector_definition_versions_paginator: greengrass_paginators.ListConnectorDefinitionVersionsPaginator = client.get_paginator("list_connector_definition_versions")
list_connector_definitions_paginator: greengrass_paginators.ListConnectorDefinitionsPaginator = client.get_paginator("list_connector_definitions")
list_core_definition_versions_paginator: greengrass_paginators.ListCoreDefinitionVersionsPaginator = client.get_paginator("list_core_definition_versions")
list_core_definitions_paginator: greengrass_paginators.ListCoreDefinitionsPaginator = client.get_paginator("list_core_definitions")
list_deployments_paginator: greengrass_paginators.ListDeploymentsPaginator = client.get_paginator("list_deployments")
list_device_definition_versions_paginator: greengrass_paginators.ListDeviceDefinitionVersionsPaginator = client.get_paginator("list_device_definition_versions")
list_device_definitions_paginator: greengrass_paginators.ListDeviceDefinitionsPaginator = client.get_paginator("list_device_definitions")
list_function_definition_versions_paginator: greengrass_paginators.ListFunctionDefinitionVersionsPaginator = client.get_paginator("list_function_definition_versions")
list_function_definitions_paginator: greengrass_paginators.ListFunctionDefinitionsPaginator = client.get_paginator("list_function_definitions")
list_group_versions_paginator: greengrass_paginators.ListGroupVersionsPaginator = client.get_paginator("list_group_versions")
list_groups_paginator: greengrass_paginators.ListGroupsPaginator = client.get_paginator("list_groups")
list_logger_definition_versions_paginator: greengrass_paginators.ListLoggerDefinitionVersionsPaginator = client.get_paginator("list_logger_definition_versions")
list_logger_definitions_paginator: greengrass_paginators.ListLoggerDefinitionsPaginator = client.get_paginator("list_logger_definitions")
list_resource_definition_versions_paginator: greengrass_paginators.ListResourceDefinitionVersionsPaginator = client.get_paginator("list_resource_definition_versions")
list_resource_definitions_paginator: greengrass_paginators.ListResourceDefinitionsPaginator = client.get_paginator("list_resource_definitions")
list_subscription_definition_versions_paginator: greengrass_paginators.ListSubscriptionDefinitionVersionsPaginator = client.get_paginator("list_subscription_definition_versions")
list_subscription_definitions_paginator: greengrass_paginators.ListSubscriptionDefinitionsPaginator = client.get_paginator("list_subscription_definitions")
```

## Automated type discovery

`mypy_boto3` package can generate index for `mypy_boto3_greengrass` and other installed services.

```bash
# Run this command when you add or remove service packages
python -m mypy_boto3
```

Generated index provides overloads for `boto3.client` and `boto3.service`,
`boto3.Session.client` and `boto3.Session.resource` functions,
so explicit type annotations are not needed.

- `mypy` supports function overloads as expected
- `PyCharm` also supports function overloads, but consumes a lot of RAM, use carefully
- `VSCode` does not currently support function overloads

Also, generated index allows you to import types from `mypy_boto3`:

```python
# you can replace imports
import mypy_boto3_greengrass as greengrass
from mypy_boto3_greengrass import GreengrassClient

# with these
from mypy_boto3 import greengrass
from mypy_boto3.greengrass import GreengrassClient
```